// AUTOGENERATED COPYRIGHT HEADER START
// Copyright (C) 2023 Michael Fabian 'Xaymar' Dirks <info@xaymar.com>
// AUTOGENERATED COPYRIGHT HEADER END

#pragma once
#include "common.hpp"
#include "obs/obs-source-factory.hpp"

#include "warning-disable.hpp"
#include <vector>
#include "warning-enable.hpp"

namespace streamfx::filter::spout {
	class asyncvideo_instance : public obs::source_instance {
		public:
		asyncvideo_instance(obs_data_t*, obs_source_t*);
		~asyncvideo_instance() override;

		void load(obs_data_t* settings) override;
		void migrate(obs_data_t* data, uint64_t version) override;
		void update(obs_data_t*) override;

		struct obs_audio_data* filter_audio(struct obs_audio_data* audio) override;

		struct obs_source_frame* filter_video(struct obs_source_frame* frame) override;
	};

	class asyncvideo_factory : public obs::source_factory<filter::spout::asyncvideo_factory, filter::spout::asyncvideo_instance> {
		public:
		asyncvideo_factory();
		~asyncvideo_factory() override;

		const char* get_name() override;

		void get_defaults2(obs_data_t* data) override;

		obs_properties_t* get_properties2(filter::spout::asyncvideo_instance* data) override;

		public: // Singleton
		static std::shared_ptr<asyncvideo_factory> instance();
	};
} // namespace streamfx::filter::spout
